﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="AllPlanningUnits.aspx.cs" Inherits="AllPlanningUnits" %>

<%@ Import Namespace="System.Data.SqlClient" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Text" %>
<%@ Import Namespace="System.Data" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<script runat="server">

</script>
<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head2" runat="server">
    <title>Strong Project Approval Band Strong</title>


    <style type="text/css">
        .BtnSend {
            width: 53px;
            height: 24px;
            display: block;
            float: right;
            margin: 0 0 0 10px;
            text-decoration: none;
            text-align: center;
            line-height: 24px;
            color: #0026ff;
        }

        .blue {
            font-size: 20px;
            color: #191966;
        }
    </style>
</head>
<body class="fluid-container">
    <link rel="stylesheet" href="<%= UrlHelper.ResolveLib("/psy_multi_css.css") %>" />
    <script src="<%= UrlHelper.ResolveLib("/jquery/jquery.js") %>"></script>
    <script src="<%= UrlHelper.ResolveLib("/bootstrap/js/bootstrap.js") %>"></script>
    <script src="<%= UrlHelper.ResolveLib("sync-fusion/js/jsrender.min.js") %>"></script>
    <script src="<%= UrlHelper.ResolveLib("sync-fusion/js/ej/ej.web.all.min.js") %>"></script>
    <script src="<%= UrlHelper.ResolveLib("sync-fusion/js/ej/ej.webform.min.js") %>"></script>
    <script src="<%= UrlHelper.ResolveLib("/pendennis/site.js") %>"></script>
    <script src="<%= UrlHelper.ResolveLib("/pendennis/band.js") %>"></script>
    <script src="<%= UrlHelper.ResolveLib("/pendennis/entity.js") %>"></script>
    <script src="<%= UrlHelper.ResolveLib("/pendennis/workpackage.js") %>"></script>

    <form id="form1" runat="server">
        <script type="text/javascript">
            function endAdd(args) {
                $('#<%= PlanningUnitsGrid.ClientID %>').ejWaitingPopup("show");
            }
            function endDelete(args) {
                $('#<%= PlanningUnitsGrid.ClientID %>').ejWaitingPopup("show");
            }
            function endEdit(args) {
                $('#<%= PlanningUnitsGrid.ClientID %>').ejWaitingPopup("show");
            }
            function complete(args) {
                if (args.requestType == "refresh") {
                    $('#<%= PlanningUnitsGrid.ClientID %>').ejWaitingPopup("hide");
                }
            }
        </script>
        <script id="Validator" type="text/ecmascript">
            $("#PlanningUnitsGrid").validate();
        </script>
        <asp:ScriptManager ID="scriptmanager" runat="server"></asp:ScriptManager>
        <script id="tabGridContents" type="text/x-jsrender">
            <div id="contact{{:EXT_Workpackage_ID }}" style="font-weight: bold; padding: 5px;">
                <div id="cont">
                    Earliest Start Date:{{:earliest_start_date }}<br />
                    Last Update:{{:last_update }}<br />
                    Created Date:{{:createdate }}<br />
                    Allocated To:{{:Allocated_To }}<br />
                    Name:{{:name }}<br />
                    Sales Budget:{{:Duration }}   Hrs<br />
                    PWP Sales Budget:{{:child_duration }}   Hrs<br />
                </div>
            </div>
        </script>
        <div>
            <table>
                <tr>
                    <td>
                        <asp:Label ID="lblNavigateUrl" ToolTip="New Planning Unit" runat="server"></asp:Label>
                    </td>
                    <td>
                        <asp:LinkButton ID="ButtonExcelButton" runat="server" OnClick="ExcelButton_Click" CssClass="blue" Text="<i class='fas fa-file-excel'></i>" />
                    </td>
                </tr>
            </table>
        </div>
        <asp:Panel ID="pnlHide" runat="server" Visible="false">
            <asp:GridView ID="gridHidden" runat="server" AutoGenerateColumns="false" CellPadding="15" CellSpacing="5" OnRowDataBound="Grid_RowDataBound">
                <Columns>
                    <asp:BoundField HeaderText="Workpackage" DataField="EXT_Workpackage_ID" SortExpression="Code" />
                    <asp:BoundField HeaderText="Name" DataField="Job" SortExpression="Name" />
                    <asp:BoundField HeaderText="Job" DataField="name" SortExpression="Job" />
                    <asp:BoundField HeaderText="Billing" DataField="billing" SortExpression="Status" />
                    <asp:BoundField HeaderText="Allocated" DataField="Allocated_To" SortExpression="Billing" />
                    <asp:BoundField HeaderText="Created Date" DataField="createdate" SortExpression="Allocated" />
                    <asp:BoundField HeaderText="Earliest Start" DataField="earliest_start_date" SortExpression="Type" />
                    <asp:BoundField HeaderText="Latest Completion" DataFormatString="{0:dd MMM yyyy}" DataField="latest_completion" SortExpression="Created" />
                    <asp:BoundField HeaderText="Last Update" DataFormatString="{0:dd MMM yyyy}" DataField="last_update" SortExpression="EarliestStart" />
                    <asp:BoundField HeaderText="Actual" ItemStyle-HorizontalAlign="Center" DataField="Actual" SortExpression="ProductionBudget" />
                    <asp:BoundField HeaderText="Duration" ItemStyle-HorizontalAlign="Center" DataField="child_duration" SortExpression="EstimatedMaterials" />
                    <asp:BoundField HeaderText="Schedule A (£)" ItemStyle-HorizontalAlign="Center" DataField="scheduleatotal" SortExpression="ScheduleA" />
                    <asp:BoundField HeaderText="Contract Type" DataField="contracttype" SortExpression="ContractType" />
                </Columns>
            </asp:GridView>
        </asp:Panel>
        <div>
            <ej:Grid AllowSearching="true" AllowSorting="true" DataSourceCachingMode="ViewState"
                ID="PlanningUnitsGrid"
                AllowFiltering="true" AllowGrouping="true" AllowSelection="false"
                DataSourceID="SqlData" ShowColumnChooser="true"
                AllowPaging="true" IsResponsive="true" DetailsTemplate="#tabGridContents"
                runat="server">
                <EditSettings AllowEditing="true" AllowAdding="true" AllowDeleting="true" ShowDeleteConfirmDialog="true"></EditSettings>
                <ToolbarSettings ShowToolbar="true" ToolbarItems="add,edit,update,cancel"></ToolbarSettings>
                <ClientSideEvents ActionComplete="oncomplete" EndAdd="endAdd" EndDelete="endDelete" EndEdit="endEdit"
                    RecordDoubleClick="doubleClick" />
                <FilterSettings FilterType="Excel"></FilterSettings>
                <PageSettings PageSize="50"></PageSettings>
                <SummaryRows>
                    <ej:SummaryRow Title="Sum">
                        <SummaryColumn>
                            <ej:SummaryColumn SummaryType="Sum" Format="{0:n1}" DisplayColumn="Actual" DataMember="Actual" />
                            <ej:SummaryColumn SummaryType="Sum" Format="£{0:n1}" DisplayColumn="est_mat" DataMember="est_mat" />
                        </SummaryColumn>
                    </ej:SummaryRow>
                </SummaryRows>
                <Columns>
                    <ej:Column HeaderText="View" Width="60px" Template="#viewTemplate" Tooltip="{{:EXT_Workpackage_ID}}"></ej:Column>
                    <ej:Column Field="EXT_Workpackage_ID" HeaderText="EXT_Workpackage_ID" Visible="false" />
                    <ej:Column Field="Workpackage_Code" HeaderText="Code" />
                    <ej:Column Field="Job" HeaderText="Job" Width="80px" />
                    <ej:Column Field="Name" HeaderText="Name" Width="20%" />
                    <ej:Column Field="billing" HeaderText="Billing" EditType="DropdownEdit" />
                    <ej:Column Field="Duration" HeaderText="Sales Budget" EditType="NumericEdit" />
                    <ej:Column Field="est_mat" HeaderText="Estimated Material" Format="£{0:n1}" />
                    <ej:Column Field="scheduleatotal" Format="£{0:n1}" HeaderText="Schedule A Total" />
                    <ej:Column Field="xm" HeaderText="Actual Material" Format="£{0:n1}" />
                    <ej:Column Field="contracttype" HeaderText="Contract Type" Format="£{0:n1}" />
                    <ej:Column Field="Description" HeaderText="Description Type" Format="£{0:n1}" />
                    <ej:Column Field="status" HeaderText="Status" />
                    <ej:Column Field="identifier" HeaderText="Job Number" />
                </Columns>
            </ej:Grid>
            <script type="text/x-jsrender" id="viewTemplate">
                <a rel='nofollow' href='/entity/entity.aspx?ec=1400&code={{:EXT_Workpackage_ID}}' target='_blank'><i class='fas fa-search blue'></i></a>
            </script>
        </div>
        <asp:SqlDataSource ID="SqlData" runat="server" ConnectionString="<%$ ConnectionStrings:workspace %>"
            SelectCommand="select
        @Entity[Entity],
        @User[User],
        a.project_id,
        b.ext_workpackage_id ,
        b.workpackage_code Workpackage_Code,
        b.name Name,
        right(b.workpackage_code,3) [Job],
        b.[Allocated_To],
        convert (integer,b.Duration,2) Duration,
        bs.name status,
        convert(varchar, b.earliest_start_date,106) earliest_start,
        convert(varchar, b.latest_completion_date,106) latest_completion,
        b.Created_Date [createddate],
        bt.name type,
        bi.name [billing],
        c2.CC_USRCHAR1 [accessbilling],
        CASE 
			when c2.CC_USRCHAR1=bi.name then '1'
			when c2.CC_USRCHAR1 is null then '0'
			else '-1'
		end [billingmatch],
		
        [workpackage/@iscomplete] = 
                 CASE
                      WHEN bs.completed = 1 THEN 1
		              WHEN bs.completed = 0 THEN 0
                 END
        ,(select SUM(hours)/60 from EXVW_TMShours h where  h.WP like b.workpackage_code + '%' collate SQL_Latin1_General_CP1_CI_AS)[Actual]
        
        ,(select CONVERT(DECIMAL(10,2),SUM(child.Duration)) from EXT_Workpackage child where child.Parent_Workpackage_ID=b.EXT_Workpackage_ID and ext_workpackage_status_id not in (3,13)) [child_duration]
        
        ,CONVERT(DECIMAL(10,2),x1m.CC_ACTUAL_COST) + CONVERT(DECIMAL(10,2),x1m.CC_COMITT_COST) [xm]
        ,CONVERT(DECIMAL(10,2),x1s.CC_ACTUAL_COST) [xs]
         
        ,CONVERT(DECIMAL(10,2),b.material_cost) [est_mat]
        ,a.last_update_time [last_update],CONVERT(DECIMAL(10,2),b.scheduleatotal)[scheduleatotal],ct.Name[contracttype]
        from project a
        join EXT_Workpackage b on a.project_id = b.project_id
        join EXT_Workpackage_Status bs on b.EXT_Workpackage_Status_ID = bs.EXT_Workpackage_Status_ID
        left outer join ext_workpackage_type bt on bt.ext_workpackage_type_id = b.ext_workpackage_type_id
        left join ext_workpackage_billing_type bi on b.billing = bi.ext_workpackage_billing_type_id

		left join Project p on a.project_id=p.project_id
		LEFT JOIN [PendennisShipyardLtd].[dbo].[CST_COSTCENTRE] x1m on b.Workpackage_Code + 'M' = p.Project_Code + x1m.cc_code and x1m.cc_copyheader=p.Project_Code
		LEFT JOIN [PendennisShipyardLtd].[dbo].[CST_COSTCENTRE] x1s on b.Workpackage_Code + 'S' = p.Project_Code + x1s.cc_code and x1s.cc_copyheader=p.Project_Code
			
        LEFT JOIN EXT_workpackage_contract_type ct on b.EXT_Workpackage_Contract_Type_ID=ct.EXT_Workpackage_Contract_Type_ID
        left join [PendennisShipyardLtd].[dbo].CST_COSTCENTRE2 c2 on x1m.CC_primary = c2.CC_PRIMARY_2
 
        left join ext_workpackage_approvable_projects wpp on a.Project_ID=wpp.project_id 
        
        where a.project_id = @Entity
        and b.Parent_Workpackage_ID is null
        
        and bt.ext_workpackage_type_id = @Parameter
		ORDER BY EXT_Workpackage_ID DESC"
            InsertCommand="EXSP_WP_Create_Alt"
            DeleteCommand="DELETE FROM [EXT_Yacht_Event_New] WHERE [Yacht_Event_ID] = @Yacht_Event_ID"
            UpdateCommand="EXSP_WP_Create_Alt">
            <SelectParameters>
                <asp:SessionParameter Name="Entity" DefaultValue="123" SessionField="Entity" Type="Int32" />
                <asp:SessionParameter Name="Parameter" DefaultValue="123" SessionField="Parameter" Type="Int32" />
                <asp:SessionParameter Name="User" DefaultValue="123" SessionField="User" Type="Int32" />
            </SelectParameters>
            <UpdateParameters>
                <asp:Parameter Name="EXT_Workpackage_Type_ID" Type="Int32" />
                <asp:Parameter Name="Estimated_Total_Hours" Type="String" />
                <asp:Parameter Name="Workpackage_Code" Type="String" />
                <asp:Parameter Name="est_mat" Type="Int32" />
                <asp:Parameter Name="Job" Type="String" />
                <asp:Parameter Name="name" Type="String" />
                <asp:Parameter Name="status" Type="String" />
                <asp:Parameter Name="identifier" Type="String" />
                <asp:Parameter Name="Description" Type="String" />
                <asp:Parameter Name="billing" Type="String" />
                <asp:Parameter Name="Duration" Type="Int32" />
                <asp:Parameter Name="Description" Type="String" />
                <asp:Parameter Name="scheduleatotal" Type="Int32" />
                <asp:Parameter Name="xm" Type="Int32" />
                <asp:Parameter Name="contracttype" Type="String" />
                <asp:Parameter Name="Job_Number" Type="String" />
                <asp:SessionParameter Name="Entity" DefaultValue="123" SessionField="Entity" Type="Int32" />
                <asp:SessionParameter Name="Parameter" DefaultValue="123" SessionField="Parameter" Type="Int32" />
                <asp:SessionParameter Name="User" DefaultValue="123" SessionField="User" Type="Int32" />
            </UpdateParameters>
            <InsertParameters>
                <asp:Parameter Name="EXT_Workpackage_Type_ID" Type="String" />
                <asp:Parameter Name="Estimated_Total_Hours" Type="Int32" />
                <asp:Parameter Name="Workpackage_Code" Type="String" />
                <asp:Parameter Name="est_mat" Type="Int32" />
                <asp:Parameter Name="Job" Type="String" />
                <asp:Parameter Name="name" Type="String" />
                <asp:Parameter Name="status" Type="String" />
                <asp:Parameter Name="identifier" Type="String" />
                <asp:Parameter Name="Description" Type="String" />
                <asp:Parameter Name="billing" Type="String" />
                <asp:Parameter Name="Duration" Type="Int32" />
                <asp:Parameter Name="Description" Type="String" />
                <asp:Parameter Name="scheduleatotal" Type="Int32" />
                <asp:Parameter Name="xm" Type="Int32" />
                <asp:Parameter Name="contracttype" Type="String" />
                <asp:Parameter Name="Job_Number" Type="Int32" />
                <asp:SessionParameter Name="Entity" DefaultValue="123" SessionField="Entity" Type="Int32" />
                <asp:SessionParameter Name="Parameter" DefaultValue="123" SessionField="Parameter" Type="Int32" />
                <asp:SessionParameter Name="User" DefaultValue="123" SessionField="User" Type="Int32" />
            </InsertParameters>
            <DeleteParameters>
                <asp:Parameter Name="EXT_Workpackage_ID" Type="Int32" />
            </DeleteParameters>
        </asp:SqlDataSource>
    </form>
</body>
</html>

